/* cs_3_osc_rr.c */

#include "head_usycams.h"
#include "def_usycams.h"
#include "objects.h"
#include "def_surfaces.h"

/*
double sc[6*POINTS+M][2][3],sf[6*POINTS+M][2][3]; 
double uc[6*POINTS+M][CPOINTS+1][3],uf[6*POINTS+M][CPOINTS+1][3]; 
double v_cam[6*POINTS+M][CPOINTS+1][3];
double v_fol[6*POINTS+M][CPOINTS+1][3];
float  nsc[6*POINTS+M][2][3],nsf[POINTS+M][2][3];
float  nuc[6*POINTS+M][CPOINTS+1][3],nuf[6*POINTS+M][CPOINTS+1][3];
float  nvc[6*POINTS+M][CPOINTS+1][3],nvf[6*POINTS+M][CPOINTS+1][3];
*/
cs_3_osc_rr(a1,alp1,a4,alp4,l)
double a1,alp1,a4,alp4,l[2];
{
 double phi,dphi,ddphi,psi,a3,alp3,dalp3;
 double k1,k3,k5,k6,h1,h2;
 double dk1,dk3,dk5,dk6,dh1,dh2;
 double e42[3],de42[3];
 double p[3]={0,0,0};
 double num,den;
 double vph; 
 double psph;
 double m[3],mag;
 double u[M][3],v[M][3];
 float  nu[M][3],nv[M][3];
 int i,j,k,n;

 if(ABS(alp1)<0.0001)
  {
     for(i=0;i<=POINTS;i++)
       {
   	psi = io[i][0];
    	phi = io[i][1];
    	dphi= io[i][2];
    	vph = 1-dphi;
    	psph= psi-phi;
    	a3  = a1*cos(phi)/(dphi-1);
	vp3_var[2] = a3;
    	for(j=0;j<2;j++)
      	  { 
	   sc[i][j][0] =  a1*cos(psi)+a3*cos(psph)+a4*sin(psph);
	   sc[i][j][1] = -a1*sin(psi)-a3*sin(psph)+a4*cos(psph);
	   sc[i][j][2] = l[j];
           m[0] = -a1*cos(psi)-a3*vph*cos(psph)-a4*vph*sin(psph);
	   m[1] =  a1*sin(psi)+a3*vph*sin(psph)-a4*vph*cos(psph);
	   m[2] = 0.;
	   mag = sqrt(SQR(m[0])+SQR(m[1]));
	   nsc[i][j][0]= -m[0]/mag;
	   nsc[i][j][1]= -m[1]/mag;
	   nsc[i][j][2]=0;
          }
        uc[i][0][0]  = 0;
        uc[i][0][1]  = 0;
        uc[i][0][2]  = l[0];
        uc[i][1][0]  = sc[i][0][0];
        uc[i][1][1]  = sc[i][0][1];
        uc[i][1][2]  = l[0];
        for(j=0;j<2;j++)
          {
    	   nuc[i][j][0] = 0;
    	   nuc[i][j][1] = 0;
    	   nuc[i][j][2] = -1;
          }
        v_cam[i][0][0]  = 0;
        v_cam[i][0][1]  = 0;
        v_cam[i][0][2]  = l[1];
        v_cam[i][1][0]  = sc[i][1][0];
        v_cam[i][1][1]  = sc[i][1][1];
        v_cam[i][1][2]  = l[1];
        for(j=0;j<2;j++)
          {
    	    nvc[i][j][0] = 0;
    	    nvc[i][j][1] = 0;
    	    nvc[i][j][2] = 1;
          }
      }
    draw_cam1_pl();
    draw_fol1_pl(1.5*vp3_var[0],-vp3_var[4],vp3_var[7]-vp3_var[6]);
   }
 else
   {
     for(i=0;i<=POINTS;i++)
       {
   	psi    = io[i][0];
    	phi    = io[i][1];
    	dphi   = io[i][2];
        ddphi  = io[i][3];
        alp3   = atan2(sin(alp1)*cos(phi),dphi-cos(alp1));
	num    = dphi*(dphi-cos(alp1))*sin(alp1)*sin(phi)
			-ddphi*sin(alp1)*cos(phi);
	den    = SQR(dphi-cos(alp1))+SQR(sin(alp1)*cos(phi));
	dalp3  = num/den;
        k1     = cos(alp1)*cos(alp3)-sin(alp1)*sin(alp3)*cos(phi);
        k3     = sin(alp1)*cos(alp3)+cos(alp1)*sin(alp3)*cos(phi);
        k5     = cos(psi)*cos(phi)+sin(psi)*sin(phi)*cos(alp1);
        k6     = sin(psi)*cos(phi)-cos(psi)*sin(phi)*cos(alp1);
        h1     = k3*sin(psi)-sin(alp3)*sin(phi)*cos(psi);
        h2     = k3*cos(psi)+sin(alp3)*sin(phi)*sin(psi);
	dk1    = -dalp3*(cos(alp1)*sin(alp3)+sin(alp1)*cos(alp3)*cos(phi))
			+dphi*sin(alp1)*sin(alp3)*sin(phi);
	dk3    = -dalp3*(sin(alp1)*sin(alp3)-cos(alp1)*cos(alp3)*cos(phi))
			-dphi*cos(alp1)*sin(alp3)*sin(phi);
	dk5    = -dphi*(cos(psi)*sin(phi)-sin(psi)*cos(phi)*cos(alp1))
			-sin(psi)*cos(phi)+cos(psi)*sin(phi)*cos(alp1);
	dk6    = -dphi*(sin(psi)*sin(phi)+cos(psi)*cos(phi)*cos(alp1))
			+cos(psi)*cos(phi)+sin(psi)*sin(phi)*cos(alp1);
	dh1    =  k3*cos(psi)+dk3*sin(psi)+sin(alp3)*sin(phi)*sin(psi)
			-dphi*sin(alp3)*cos(phi)*cos(psi)
			-dalp3*cos(alp3)*sin(phi)*cos(psi);
	dh2    = -k3*sin(psi)+dk3*cos(psi)+sin(alp3)*sin(phi)*cos(psi)
			+dphi*sin(alp3)*cos(phi)*sin(psi)
			+dalp3*cos(alp3)*sin(phi)*sin(psi);
        e42[0] =  -(k5*sin(alp4)-h1*cos(alp4));
        e42[1] = -(-k6*sin(alp4)-h2*cos(alp4));
        e42[2] =  -(sin(alp1)*sin(phi)*sin(alp4)+k1*cos(alp4));
        de42[0]=  -(dk5*sin(alp4)-dh1*cos(alp4));
	de42[1]= -(-dk6*sin(alp4)-dh2*cos(alp4));
	de42[2]= -(dphi*sin(alp1)*cos(phi)*sin(alp4)+dk1*cos(alp4));
        cross_prod(de42,e42,m);
	mag = sqrt(SQR(m[0])+SQR(m[1])+SQR(m[2]));
        cover_surf(p,e42,l,u,nu,v,nv);
       for(j=0;j<=CPOINTS;j++)
         {
          for(k=0;k<3;k++)
            {
             uc[i][j][k]  = u[j][k];
             nuc[i][j][k] = nu[j][k];
             v_cam[i][j][k]  = v[j][k];
             nvc[i][j][k] = nv[j][k];
            }
          }
    	for(j=0;j<2;j++)
      	  {
           for(k=0;k<3;k++)
             { 
	      sc[i][j][k] = l[j]*e42[k];
	      nsc[i][j][k]= -m[k]/mag;
             }
          }
       }
    draw_cam1_sph();
    draw_fol1_sph(1.5*vp3_var[1],-vp3_var[5],l);
   }
}


draw_cam1_pl()
{
 double v1[3],v2[3];
 float  n1[3],n2[3];
 int    i,j,k;


 makeobj(CAM);
	   lmbind(MATERIAL,C_CAM); /* steel */
   for (k=0; k<1; k++)
     {
      bgnqstrip();
      for (i=0; i<=POINTS; i++)      
       {
         for(j=0;j<3;j++)
           {
            v1[j]=sc[i][k][j];
            v2[j]=sc[i][k+1][j];
            n1[j]= nsc[i][k][j];
            n2[j]= nsc[i][k+1][j];
           }
         n3f(n2);
         v3d(v2);
         n3f(n1);
         v3d(v1);
       }
      endqstrip();
     }

   for(k=0;k<1;k++)
     {
      bgnqstrip();
      for(i=POINTS;i>=0;i--)
       {
        for(j=0;j<3;j++)
          {
           v1[j] = uc[i][k][j];
           v2[j] = uc[i][k+1][j];
           n1[j] = nuc[i][k][j];
           n2[j] = nuc[i][k+1][j];
          }
        n3f(n2);
        v3d(v2);
        n3f(n1);
        v3d(v1);
       }
      endqstrip();
     }

   for(k=0;k<1;k++)
     {
      bgnqstrip();
      for(i=0;i<=POINTS;i++)
       {
        for(j=0;j<3;j++)
          {
           v1[j] = v_cam[i][k][j];
           v2[j] = v_cam[i][k+1][j];
           n1[j] = nvc[i][k][j];
           n2[j] = nvc[i][k+1][j];
          }
        n3f(n2);
        v3d(v2);
        n3f(n1);
        v3d(v1);
       }
      endqstrip();
     }
 closeobj();
}

draw_fol1_pl(lm,h,th) /* length, a4, thick */
double lm,h,th;
{
 makeobj(PFOL);
  pushmatrix();
   translate(-lm/2.,0.,th/2.);
   draw_cube(lm,.8*th,th);
   translate(0.,.8*th,0.);
   rotate(1800,'z');
   cylindft(.8*th,th,PI/2.,1.);
   pushmatrix();
    rotate(900,'x');
    draw_plane(.8*th,th,1.);
   popmatrix();
   translate(-lm,0.,0.);
   rotate(900,'z');
   cylindft(.8*th,th,PI/2.,1.);
   pushmatrix();
    rotate(-900,'y');
    draw_plane(th,.8*th,1.);
   popmatrix();   
  popmatrix();
 closeobj();

 makeobj(FOL);
           lmbind(MATERIAL,C_FOL);
  pushmatrix();
   translate(0.,0.,-th);
   if(h>0)
     cylindft(.8*th,th,PI,1.);
   else
     {
      pushmatrix();
       rotate(1800,'z');
       cylindft(.8*th,th,PI,1.);
      popmatrix();
     }
   if(h>0)
     {
      pushmatrix();
       translate(-.8*th,-h-.8*th,0.);
       draw_cube(1.6*th,h+.8*th,th);
      popmatrix();
     }
   else
     {
      pushmatrix();
       translate(-.8*th,0.,0.);
 if(h<-vp3_var[0]*sin(vp4_var[1]))
      draw_cube(1.6*th,-h+.8*th,th);
else
      draw_cube(1.6*th,-h,th);

      popmatrix();
     }
  popmatrix();
  pushmatrix();
   if(h<-vp3_var[0]*sin(vp4_var[1]))
    {
     rotate(1800,'x');
     translate(-(lm-1.6*th)/2.*cos(vp4_var[1]),-.8*th+h,-3*th/2);
    }
   else
    translate(-(lm-1.6*th)/2.*cos(vp4_var[1]),-.8*th-h,-th/2);
   callobj(PFOL);
  popmatrix();
 closeobj();
}

draw_cam1_sph()
{
 double v1[3],v2[3];
 float  n1[3],n2[3];
 int    i,j,k;


 makeobj(CAM);
          lmbind(MATERIAL,C_CAM); 
   for (k=0; k<1; k++)
     {
      bgnqstrip();
      for (i=0; i<=POINTS; i++)
       {
         for(j=0;j<3;j++)
           {
            v1[j]=sc[i][k][j];
            v2[j]=sc[i][k+1][j];
            n1[j]= nsc[i][k][j];
            n2[j]= nsc[i][k+1][j];
           }
         n3f(n1);
         v3d(v1);
         n3f(n1);
         v3d(v2);
       }
      endqstrip();
     }

   for(k=0;k<CPOINTS;k++)
     {
      bgnqstrip();
      for(i=POINTS;i>=0;i--)
       {
        for(j=0;j<3;j++)
          {
           v1[j] = uc[i][k][j];
           v2[j] = uc[i][k+1][j];
           n1[j] = nuc[i][k][j];
           n2[j] = nuc[i][k+1][j];
          }
        n3f(n2);
        v3d(v2);
        n3f(n1);
        v3d(v1);
       }
      endqstrip();
     }

   for(k=0;k<CPOINTS;k++)
     {
      bgnqstrip();
      for(i=POINTS;i>=0;i--)
       {
        for(j=0;j<3;j++)
          {
           v1[j] = v_cam[i][k][j];
           v2[j] = v_cam[i][k+1][j];
           n1[j] = nvc[i][k][j];
           n2[j] = nvc[i][k+1][j];
          }
        n3f(n2);
        v3d(v2);
        n3f(n1);
        v3d(v1);
       }
      endqstrip();
     }
 closeobj();
}

draw_fol1_sph(psi,alp4,l) /* length, a4, thick */
double psi,alp4,l[2];
{
 double l_int[2],l_ext[2],l_ch[2];
 
 l_int[0]=2*l[0]-l[1];
 l_int[1]=l[0];

 l_ext[0]=l[1];
/* l_ext[1]=2*l[1]-l[0];*/
 l_ext[1]=l[1]+.2;
 l_ch[0]=l[1];
 l_ch[1]=l[1]+.3;
 makeobj(FOL);
           lmbind(MATERIAL,C_FOL);
  pushmatrix();
   if(alp4<=0)
    {
     rotate(900,'z');
     pushmatrix();
      rotate(-900,'y');
    /*  rotate(1800,'x');*/
      draw_sph_vol(8*PI/18.,PI/2.001,2*PI,l_ch);
     popmatrix();
     draw_sph_vol(-PI/18.,PI/18.,ABS(alp4)+PI/16.,l_ext);
    }
   else 
    {
     rotate(-900,'z');
     pushmatrix();
      rotate(-900,'y');
     /* rotate(1800,'x');*/
      draw_sph_vol(8*PI/18.,PI/2.001,2*PI,l_ch);
     popmatrix();
     draw_sph_vol(-PI/18.,PI/18.,ABS(alp4),l_ext);
    }
  popmatrix();
  pushmatrix();
/*   rotate(100+(int)(1800/PI*psi*sin(vp3_var[1])*sin(vp4_var[1]/2.)),'x');
   rotate(100+(int)(1800/PI*psi*sin(vp4_var[1]/2.)),'x');*/

/*   if(alp4<=0)
     {*/
      draw_sph_vol(-PI/16.+alp4,alp4,2*PI,l);
/*     }
   else
     {
      draw_sph_vol(-PI/16.+alp4,alp4,psi,l);
     }*/
  popmatrix();
 closeobj();
}
