/* draw_i_vp3_vp4.c */

#include "head_usycams.h"
#include "objects.h"
#include "def_usycams.h"

draw_i_vp3_vp4()
{
 int   i;
 double v1[3][2]={{-16.,10.},{-11.,6.},{-18.,-3.}};
 fmfonthandle f1,f2,f3,f4;

 fminit();
 f1 = fmfindfont("Times-Roman");
 f2 = fmscalefont(f1,14.0*scala); 
 f3 = fmfindfont("Symbol");
 f4 = fmscalefont(f3,14.0*scala);

 makeobj(BLOC);
   pmv(55*(float)vp3_var[6],-17,0.);
   pdr(55*(float)vp3_var[7],-17,0.);
   pdr(55*(float)vp3_var[7],-2,0.);
   pdr(55*(float)vp3_var[6],-2,0.);
   pclos();
 closeobj();

 makeobj(D1DI);
   pushmatrix();
   scale(1.,.75,1.);
   pushmatrix();
     translate(-31*(float)vp3_var[0],-12,0.);
     move(-19,0.,0.);
     rdr(38,0.,0.);
   popmatrix();
   move(-31*(float)vp3_var[0],-31,0.);
   rdr(0.,38,0.);
   rmv(0.,5,0.);
   rdr(0.,23,0.);
   pushmatrix();
     translate(31*(float)vp3_var[0],-12,0.);
     move(-19,0.,0.);
     rdr(38,0.,0.);
   popmatrix();
   move(31*(float)vp3_var[0],-31,0.);
   rdr(0.,38,0.);
   rmv(0.,5,0.);
   rdr(0.,23,0.);
   move(-31*(float)vp3_var[0],27,0.);
   draw(31*(float)vp3_var[0],27,0.);
   popmatrix();
 closeobj();

 makeobj(A1DI);
   pushmatrix();
   scale(.75,.75,1.);
   callobj(COOR);
   arc(0.,-12,40,0,(int)(vp3_var[1]*1800/PI));
   pushmatrix();
      translate(0.,-12,0.);
      rotate((int)(vp3_var[1]*1800/PI),'z');
      move(-5,0.,0.);
      rdr(55.,0.,0.);
   popmatrix();
   popmatrix();
 closeobj();

 makeobj(D3DI);
   pushmatrix();
   scale(1.,.75,1.);
   pushmatrix();
     translate(-31*(float)vp3_var[2],-12,0.);
     move(-19,0.,0.);
     rdr(38,0.,0.);
   popmatrix();
   move(-31*(float)vp3_var[2],-31,0.);
   rdr(0.,38,0.);
   rmv(0.,5,0.);
   rdr(0.,23,0.);
   pushmatrix();
     translate(31*(float)vp3_var[2],-12,0.);
     move(-19,0.,0.);
     rdr(38,0.,0.);
   popmatrix();
   move(31*(float)vp3_var[2],-31,0.);
   rdr(0.,38,0.);
   rmv(0.,5,0.);
   rdr(0.,23,0.);
   move(-31*(float)vp3_var[2],27,0.);
   draw(31*(float)vp3_var[2],27,0.);
   popmatrix();
 closeobj();

 makeobj(A3DI);
   pushmatrix();
   scale(.75,.75,1.);
   callobj(COOR);
   arc(0.,-12,40,0,(int)(vp3_var[3]*1800/PI));
   pushmatrix();
      translate(0.,-12,0.);
      rotate((int)(vp3_var[3]*1800/PI),'z');
      move(-5,0.,0.);
      rdr(55.,0.,0.);
   popmatrix();
   popmatrix();
 closeobj();


 makeobj(D4DI);
   pushmatrix();
   scale(1.,.75,1.);
   pushmatrix();
     translate(-31*(float)vp3_var[4],-12,0.);
     move(-19,0.,0.);
     rdr(38,0.,0.);
   popmatrix();
   move(-31*(float)vp3_var[4],-31,0.);
   rdr(0.,38,0.);
   rmv(0.,5,0.);
   rdr(0.,23,0.);
   pushmatrix();
     translate(31*(float)vp3_var[4],-12,0.);
     move(-19,0.,0.);
     rdr(38,0.,0.);
   popmatrix();
   move(31*(float)vp3_var[4],-31,0.);
   rdr(0.,38,0.);
   rmv(0.,5,0.);
   rdr(0.,23,0.);
   move(-31*(float)vp3_var[4],27,0.);
   draw(31*(float)vp3_var[4],27,0.);
   popmatrix();
 closeobj();

 makeobj(A4DI);
   pushmatrix();
   scale(.75,.75,1.);
   callobj(COOR);
   arc(0.,-12,40,0,(int)(vp3_var[5]*1800/PI));
   pushmatrix();
      translate(0.,-12,0.);
      rotate((int)(vp3_var[5]*1800/PI),'z');
      move(-5,0.,0.);
      rdr(55.,0.,0.);
   popmatrix();
   popmatrix();
 closeobj();

 makeobj(LRIG);
   pushmatrix();
   scale(1.,.75,1.);
   pushmatrix();
      translate(0.,8,0.);
      callobj(COOR);
      callobj(BLOC);
      move(55*(float)vp3_var[7],-17,0.);
      draw(55*(float)vp3_var[7],23,0.);
      move(0.,15,0.);
      rdr(55*(float)vp3_var[7],0.,0.);
   popmatrix();
   popmatrix();
 closeobj();

 makeobj(LLEF);
   pushmatrix();
   scale(1.,.75,1.);
   pushmatrix();
      translate(0.,8,0.);
      callobj(COOR);
      callobj(BLOC);
      move(55*(float)vp3_var[6],-17,0.);
      draw(55*(float)vp3_var[6],23,0.);
      move(0.,15,0.);
      rdr(55*(float)vp3_var[6],0.,0.);
   popmatrix();
   popmatrix();
 closeobj();

/*
 if(IND)
  {
   makeobj(PHIM);
     move2(-8.,-32.); draw2(15.,-32.);
     move2(-8.,-2.);  draw2(15.,-2);
     move2(2.,-32.);  draw2(2.,-2.);
   closeobj();

   makeobj(FIND);
     c3f(yellow);
     rect(-65.,-55.,65.,55.);
     move2(-65.,-2.); draw2(-56.,-2.);
     move2(-65.,-32.); draw2(-56.,-32.);
     move2(-50.,-50.); draw2(-50.,-38.);
     move2(20.,-50.); draw2(20.,42.);
     move2(-50.,38.); draw2(-50.,-32.); draw2(57.,-32.);
     move2(20.,42.); draw2(52.,42.);
     pushmatrix();
      translate(-15.,20.,0.);
      scale(70.,44.,1.);
      callobj(SPLI);
     popmatrix();
   closeobj();

   makeobj(PSI2);
     move2(-30.,0.); draw2(-30.,27.);
     move2(40.,0.); draw2(40.,27.);
     move2(-30.,9.); draw2(40.,9.);
   closeobj();

   makeobj(STEP);
     pushmatrix();
     scale(1.,.75,1.);
        for(i=0;i<(int)vp4_var[5];i++)
          {
           pushmatrix();
              rotate(900+3600/(int)vp4_var[5]*i,'z');
              move2(0.,0.);
              draw2(30,0.); 
           popmatrix();
          }       
     popmatrix();
   closeobj();
  }
 else
  {
   makeobj(FOSC);
     c3f(yellow);
     rect(-85,-44,85,44);
     move2(-11,20); draw2(-11,-26); draw2(80,-26);
     move2(-52,13); draw2(14,13);
     move2(-52,-9); draw2(-15,-9);
     move2(-47,-9); draw2(-47,13);
     move2(-23,-26); draw2(-23,-9);
     move2(-26,-26); draw2(-15,-26);
     move2(-11,-44); draw2(-11,-30);
     move2(4,-44); draw2(4,-13);
     move2(24,-44); draw2(24,9);
     move2(49,-44); draw2(49,9);
     move2(76,-26); draw2(76,-9);
     move2(-11,-9); draw2(4,-9);
     move2(24,13); draw2(49,13);
     pushmatrix();
      translate(14.,2.,0.);
      scale(20.,22.,1);
      callobj(SPLI);
     popmatrix();
     pushmatrix();
      translate(62.,2.,0.);
      scale(27.,22.,1.);
      rotate(1800,'y');
      callobj(SPLI);
     popmatrix();
   closeobj();

   makeobj(PSI1);
     move2(-11,0); draw2(-11,19);
     move2(4,-19); draw2(4,19);
     move2(24,-19); draw2(24,19);
     move2(49,-19); draw2(49,19);
     move2(-11,4); draw2(4,4);
   closeobj();

   makeobj(PSI2);
     move2(4,-3); draw2(4,19);
     move2(24,-19); draw2(24,19);
     move2(49,-19); draw2(49,19);
     move2(4,4); draw2(24,4);
   closeobj();

   makeobj(PSI3);
     move2(24,-3); draw2(24,19);
     move2(49,-3); draw2(49,19);
     move2(24,4); draw2(49,4);
   closeobj();
  }*/
}

