/* main_usycams.c */

#include "head_usycams.h"
#include "def_usycams.h"
/*#include "attrib_usycams.h"*/
#include "objects.h"
/*#include "def_surfaces.h"*/


draw_solids()
{
 int j;
 double rad,rad1;
 double th;
 
 th=(vp3_var[7]-vp3_var[6]);
  switch(mech_id)
    {
    case three_osc_rr:
      pushmatrix();
        scale(2.,2.,2.);
        pushmatrix();
          if(ABS(vp3_var[1])<0.0001 && vp3_var[0]>.001)
            translate(vp3_var[0],0.,vp3_var[6]);
          rotate((int)(vp3_var[1]*1800/PI),'x');
	  rotate((int)(io[POINTS-counter][1]*1800/PI),'z');
	  callobj(FOL);
        popmatrix(); 
   
        pushmatrix();
          rotate(-psii[counter],'z');
          callobj(CAM);
        popmatrix();
      popmatrix(); 
      break;
    case three_osc_rp:
      pushmatrix();
        scale(2.,2.,2.);
        pushmatrix();
          translate(0.0,th/2.,
		-(vp4_var[1]+vp4_var[0]/2.)*cos(vp3_var[1])+(vp3_var[7]+vp3_var[6])/2.);
          pushmatrix();
            rotate(-(int)(vp3_var[1]*1800/PI),'x');
	    pushmatrix();
	      translate(0.,0.,2*vp4_var[1]+vp4_var[0]); 
              lmbind(MATERIAL, C_FRAME);
	      cylind_fillet(th,2*th,th/10.,th/10.,10);
	    popmatrix();
            translate(0.,0.,io[POINTS-counter][1]);
            callobj(FOL);
          popmatrix();
        popmatrix();
   
        pushmatrix();
          rotate(-psii[counter],'z');
          callobj(CAM);
        popmatrix();
     popmatrix(); 
      break;
    case three_osc_pr:
      pushmatrix();
	scale(2.,2.,2.);
        pushmatrix();
	    translate(vp3_var[0], 0., 0.);
	    rotate((int)(vp3_var[1]*1800/PI), 'x');
	    translate(0., 0., vp3_var[6]);
	    rotate((int)(io[POINTS-counter][1]*1800/PI),'z');
	    callobj(FOL);
        popmatrix(); 
        pushmatrix();
	    translate(0.,0.,io[POINTS-counter][0]);
	    callobj(CAM);
        popmatrix();
      popmatrix();
      break;
    case three_osc_pp:
      break;
    case three_ind_rr:
      pushmatrix();
      scale(2.,2.,2.);
      translate(-vp3_var[0]/2.,0.,0.);
      pushmatrix();
      translate(vp3_var[0]*1.0,0.0,0.0);
      rotate(-(int)(vp3_var[1]*1800/PI),'x');
      rotate(phii[counter],'z');
      callobj(FOL);
      popmatrix();
  
      pushmatrix();
      rotate(-psii[counter],'z');
      callobj(CAM);
      popmatrix(); 
      break;
    case three_ind_rp:
      break;
    case three_ind_pr:
      break;
    case three_ind_pp:
      break;
    case four_osc_rr:
      break;
    case four_osc_rp:
      break;
    case four_osc_pr:
      break;
    case four_osc_pp:
      break;
    case four_ind_rr:
      pushmatrix();
      scale(2.,2.,2.);
      pushmatrix();
      translate(vp3_var[0]*1.0,0.0,0.0);
      rotate((int)(vp3_var[1]*1800/PI),'x');
      callobj(FOL);
      for(j=0;j<(int)vp4_var[5];j++)
	{
	  pushmatrix();
	  rotate(phii[counter]+3600/(int)vp4_var[5]*j,'z');
	  translate(vp3_var[2],0.,0.);
	  rotate((int)(vp3_var[3]*1800/PI),'x');
	  lmbind(MATERIAL, C_PINS);
	  rad = .6*ABS(vp3_var[4]);
	  rad1 = vp3_var[6]*ABS(sin(vp3_var[5]))*.7;
	  if(rad1>rad)
	    rad  = rad1;
	  cylindf(rad,vp3_var[7]*1.02,1.);
	  /*            cylind_fillet(rad,l[1]*1.02,.05*rad,.05*rad,3);*/
	  if(counter<= POINTS)
	    {
	      if(j==0)
		translate(0.,0.,slide34[counter]);
	      else
		translate(0.,0.,slide34[0]);
	    }
	  else 
	    {
	      if(j==1)
		translate(0.,0.,slide34[counter]);
	      else
		translate(0.,0.,slide34[0]);
	    }
	  callobj(ROLLER);
	  popmatrix();
	}
      popmatrix();

      pushmatrix();
      rotate(psii[counter],'z');
      callobj(CAM);
      popmatrix();
      pushmatrix();
      /*         translate(0.,0.,(l[1]+l[0])/2.);
		 if(a1>0.00001)
		 cylindf(.2*a1,(l[1]-l[0])/2.+.2*l[1],1.);*/
      popmatrix();
      popmatrix();
      break;
    case four_ind_rp:
      break;
    case four_ind_pr:
      break;
    case four_ind_pp:
      break;
    }
}
