/* select_vp1.c */

#include "head_usycams.h"
#include "def_usycams.h"

void select_vp1(disp_prog, rise, retu)
int disp_prog[1], rise[1], retu[1];
{
  D1D=A1D=D3D=A3D=D4D=A4D=LRI=LLE=FALSE;
  PHM=DPH=PS1=PS2=PS3=STP=FALSE;
  if(LIN3)
    {
      if(!IND)
	{
	  DI_3_OSC=TRUE; DI_3_IND=FALSE; DI_4=FALSE;
	  if(REVI)
	    {
	      if(REVO)
		{
		  mech_id=three_osc_rr; 
		  vp1_3_osc_rr(rise,retu);
		  return;
		}
	      else
		{
		  mech_id=three_osc_rp;
		  vp1_3_osc_rp(rise,retu);
		  return;
		}
	    }
	  else
	    {
	      if(REVO)
		{
		  mech_id=three_osc_pr;
		  vp1_3_osc_pr(rise,retu);
		  return;
		}
	      else
		{
		  mech_id=three_osc_pp;
		  vp1_3_osc_pp(rise,retu);
		  return;
		} 
	    }
	}
      else
	{
	  DI_3_OSC=FALSE; DI_3_IND=TRUE; DI_4=FALSE;
	  if(REVI)
	    {
	      if(REVO)
		{
		  mech_id=three_ind_rr;
		  vp1_3_ind_rr(rise);
		  return;
		}
	      else
		{
		  mech_id=three_ind_rp;
		  vp1_3_ind_rp(rise);
		  return;
		}
	    }
	  else
	    {
	      if(REVO)
		{
		  mech_id=three_ind_pr;
		  vp1_3_ind_pr(rise);
		  return;
		}
	      else
		{
		  mech_id=three_ind_pp;
		  vp1_3_ind_pp(rise);
		  return;
		}
	    }
	}
    }
  else
    {
      DI_3_OSC=FALSE; DI_3_IND=FALSE; DI_4=TRUE;
      if(!IND)
	{
	  if(REVI)
	    {
	      if(REVO)
		{
		  mech_id=four_osc_rr;
		  vp1_4_osc_rr(rise,retu);
		  return;
		}
	      else
		{
		  mech_id=four_osc_rp;
		  vp1_4_osc_rp(rise,retu);
		  return;
		}
	    }
	  else
	    {
	      if(REVO)
		{
		  mech_id=four_osc_pr;
		  vp1_4_osc_pr(rise,retu);
		  return;
		}
	      else
		{
		  mech_id=four_osc_pp;
		  vp1_4_osc_pp(rise,retu);
		  return;
		} 
	    }
	}
      else
	{
	  if(REVI)
	    {
	      if(REVO)
		{
		  mech_id=four_ind_rr;
		  vp1_4_ind_rr(rise);
		  return;
		}
	      else
		{
		  mech_id=four_ind_rp;
		  vp1_4_ind_rp(rise);
		  return;
		}
	    }
	  else
	    {
	      if(REVO)
		{
		  mech_id=four_ind_pr;
		  vp1_4_ind_pr(rise);
		  return;
		}
	      else
		{
		  mech_id=four_ind_pp;
		  vp1_4_ind_pp(rise);
		  return;
		}
	    }
	}
    }
}





