

float idmat[4][4] = 
{
    1.0, 0.0, 0.0, 0.0,
    0.0, 1.0, 0.0, 0.0,
    0.0, 0.0, 1.0, 0.0,
    0.0, 0.0, 0.0, 1.0
  };

float n1[3] = { 0., 1., 0.};
float n2[3] = { 0., 0., 1.};
float n3[3] = { 0., -1., 0.};
float n4[3] = { 0., 0., -1.};
float n5[3] = { 1., 0., 0.};
float n6[3] =  { -1., 0., 0.};
float ns1[3] = {.707, .707, 0.};
float ns2[3] = {-.707, .707, 0.};
float ns3[3] = {0., -1., 0.};
float ns4[3] = {0., 0., 1.};
float ns5[3] = {0., 0., -1.};

float shiny_material[] =
	{ SPECULAR, .8, .8, .8,
	  DIFFUSE,  .4, .4, .4,
	  SHININESS, 5.,
	  LMNULL};
 
float dark_material[] =
	{ SPECULAR, .5, .5, .7,
	  DIFFUSE,  .1, .2, .1,
	  SHININESS, 30.,
          ALPHA, 1.,
	  LMNULL};

float purple[] =
	{ SPECULAR,.8,.8,.8,
	  DIFFUSE,.529,.0,.188,
	  SHININESS,20.,
	  LMNULL};


float vainilla_mat[] =
	{ SPECULAR, .48, .3, .18,
	  DIFFUSE,  .796, .753, .263,
	  SHININESS, 20.,
          ALPHA, 1.,
	  LMNULL};

float blue_mat[] =
	{ SPECULAR,.051, .569, .474,
	  DIFFUSE,  .0, .408, .529,
	  SHININESS, 30.,
          ALPHA, 1.,
	  LMNULL};

float grey_mat[] =
	{ SPECULAR,.0, .149, .2,
	  DIFFUSE,  .067, .251, .302,
	  SHININESS, 30.,
          ALPHA, 1.,
	  LMNULL};

float bluedark_mat[] =
	{ SPECULAR,.0, .154, .392,
          DIFFUSE,  .129, .08, 1.,
	  AMBIENT,  0.0, 0.102, 0.16,
	  SHININESS, 20.,
          ALPHA, 1.,
	  LMNULL};

float plastic[] =
	{ SPECULAR, .776, 1, 1.,
	  DIFFUSE,  .666, .86, 0.91,
	  SHININESS, 60.,
          ALPHA, 0.4,
	  LMNULL};

float magentatrans[] =
	{ SPECULAR, .8, .8, .8,
	  DIFFUSE,  .411, .129, .459,
	  SHININESS, 20.,
          ALPHA, .7,
	  LMNULL};
float yellow_material[] =
	{ 
          AMBIENT, .776,1.,1.,
          SPECULAR, .808, .898, .216,
	  DIFFUSE,  1., 1., 0.,
	  SHININESS, 30.,
	  LMNULL};

float red_material[] =
	{ SPECULAR, .4, .4, .4,
	  DIFFUSE,  .8, 0.1, 0.1,
	  SHININESS, 30.,
          ALPHA, 1.,
	  LMNULL};

float red_trans[] =
	{ SPECULAR, .4, .4, .4,
	  DIFFUSE,  1., 0., 0.,
	  SHININESS, 30.,
          ALPHA, .4,
	  LMNULL};

float orange_mat[] =
	{ SPECULAR, .4, .4, .4,
	  DIFFUSE,  1., 0.282, 0.078,
	  SHININESS, 30.,
          ALPHA, 1.,
	  LMNULL};

float steel[] =
	{ SPECULAR, .776, 1, 1.,
	  DIFFUSE,  .666, .86, 0.91,
	  SHININESS, 60.,
          ALPHA, .2,
	  LMNULL};

float steel1[] =
	{ SPECULAR, .776, .8, .8,
	  DIFFUSE,  .666, .86, 0.91,
	  SHININESS, 60.,
          ALPHA, 1.,
	  LMNULL};

float steel2[] =
	{ SPECULAR, .225, .220, .2,
	  DIFFUSE,  .1, .1, 0.15,
	  SHININESS, 10.,
          ALPHA, 1.,
	  LMNULL};

float steel3[] =
	{ SPECULAR, .776, 1, 1.,
	  DIFFUSE,  .666, .86, 0.91,
	  SHININESS, 60.,
          ALPHA, .8,
	  LMNULL};

float steel4[] =
	{
          SPECULAR, .705, .757, 805,
	  DIFFUSE,  .759, .929, .918,
	  SHININESS, 60.,
          ALPHA, 1.,
	  LMNULL};

float green_material[] =
	{ 
          SPECULAR, .8, .8, .8,
	  DIFFUSE,  .302, .502, 0.251,
	  SHININESS, 30.,
          ALPHA, 1.,
	  LMNULL};

float marron[] =
	{ 
          SPECULAR, .8, .8, .8,
          DIFFUSE,  .325, .098,.098,
	  SHININESS, 30.,
          ALPHA, 1.,
	  LMNULL};

float copper[] =
	{
          SPECULAR, .7, .7, .7,
	  DIFFUSE,  .497, 0.274, 0.094,
	  SHININESS, 30.,
          ALPHA, 1.,
	  LMNULL};

float copper1[] =
	{ 
	  DIFFUSE,  .497, 0.274, 0.094,
	  SHININESS, 30.,
          ALPHA, .9,
	  LMNULL};

float copper2[] =
	{ 
	  DIFFUSE,  .497, 0.274, 0.094,
	  SHININESS, 30.,
          ALPHA, .7,
	  LMNULL};

float copper3[] =
	{ 
	  DIFFUSE,  .497, 0.274, 0.094,
	  SHININESS, 30.,
          ALPHA, .5,
	  LMNULL};

float copper4[] =
	{
	  DIFFUSE,  .497, 0.274, 0.094,
	  SHININESS, 30.,
          ALPHA, .3,
	  LMNULL};

float white3_light[] =
	{ LCOLOR, .9, .9, .9,
	  POSITION, .5, 0, 1., 0,
	  LMNULL};
/*
float white3_light[] =
	{ LCOLOR, 1.0, 1.0, 1.0,
	  POSITION, 0., 10., 5., 1.,
	  LMNULL};*/

float white4_light[] =
	{ LCOLOR, .8, .8, .8,
	  POSITION, 4., 0., 1., 0,
	  LMNULL};

float white5_light[] =
	{ LCOLOR, .5, .5, .5,
	  POSITION, 20., -2., .0, 1.,
	  LMNULL};


float mat[] = {
  AMBIENT, .4,.5,.5,
  DIFFUSE, .192, .247, .31,
  SPECULAR, .5,.5,.5,
  SHININESS, 5,
  LMNULL,
};

float beige[] = {
  AMBIENT, .784,.380,.0,
  DIFFUSE, 0.639,.408,.184,
  SPECULAR, .5,.5,.5,
  SHININESS, 50,
  ALPHA, .85,
  LMNULL,
};

static float lm[] = {
  AMBIENT, 0.5,0.5,0.5,
  LOCALVIEWER, 1,
  LMNULL
};

static float lm2[] = {
  AMBIENT, .3,.3,.3,
  LOCALVIEWER, 1,
  LMNULL
};

static float lt[] = {
  LCOLOR, 1., .75, .75,
  POSITION, 0.,0.,3.,0,
  LMNULL
};

static float lt2[] = {
  LCOLOR, 1, .7, .7,
  POSITION, 0,0,1,0,
  LMNULL
};


void def_light_calc() {
        lmdef(DEFMATERIAL, 1,  0, mat);
        lmdef(DEFMATERIAL, 2,  0, beige);
	lmdef(DEFMATERIAL, 3, 11, yellow_material);
	lmdef(DEFMATERIAL, 4, 11, red_material);
	lmdef(DEFMATERIAL, 5, 11, plastic);
	lmdef(DEFMATERIAL, 6, 11, copper);
	lmdef(DEFMATERIAL, 7, 11, purple);
	lmdef(DEFMATERIAL, 8, 11, green_material);
	lmdef(DEFMATERIAL, 9, 11, magentatrans);
	lmdef(DEFMATERIAL,10, 11, steel);
	lmdef(DEFMATERIAL,11, 11, grey_mat);
	lmdef(DEFMATERIAL,26, 11, bluedark_mat);
	lmdef(DEFMATERIAL,13, 11, vainilla_mat);
/*	lmdef(DEFMATERIAL,14, 11, steel1);*/
	lmdef(DEFMATERIAL,14, 11, vainilla_mat);
	lmdef(DEFMATERIAL,15, 11, steel2);
	lmdef(DEFMATERIAL,16, 11, steel3);
	lmdef(DEFMATERIAL,17, 11, steel4);
	lmdef(DEFMATERIAL,18, 11, copper1);
	lmdef(DEFMATERIAL,19, 11, copper2);
	lmdef(DEFMATERIAL,20, 11, copper3);
	lmdef(DEFMATERIAL,21, 11, copper4);
	lmdef(DEFMATERIAL,22, 11, marron);
	lmdef(DEFMATERIAL,23, 11, orange_mat);
	lmdef(DEFMATERIAL,24, 11, red_trans);
	lmdef(DEFMATERIAL,25, 11, dark_material);
/*	lmdef(DEFMATERIAL,26, 11, dark_material);*/
	lmdef(DEFLIGHT, 3, 10, white3_light);
	lmdef(DEFLIGHT, 4, 10, white4_light);
	lmdef(DEFLIGHT, 5, 10, white5_light);
        lmdef(DEFLIGHT,1,0,lt);
        lmdef(DEFLIGHT,2,0,lt2);
        lmdef(DEFLMODEL,1,0,lm);
        lmdef(DEFLMODEL,2,0,lm2);
}



/*---------------------------------------------------*/
void use_light_calc()
{
/*	lmbind(LIGHT0, 4);*/
	lmbind(LIGHT0, 3);
}



/*---------------------------------------------------*/
